#!/Users/scrosby/virtuals/py27/bin/python
# encoding: utf-8
'''
bin.gus_create_test_cases -- shortdesc

bin.gus_create_test_cases is a description

It defines classes_and_methods

@author:     user_name

@copyright:  2014 organization_name. All rights reserved.

@license:    license

@contact:    user_email
@deffield    updated: Updated
'''

import sys
import os

from optparse import OptionParser
from gus.BacklogClient import BacklogClient
from gus.QAForceClient import QAForceClient

__all__ = []
__version__ = 0.1
__date__ = '2014-08-19'
__updated__ = '2014-08-19'

def main(argv=None):
    '''Command line options.'''

    program_name = os.path.basename(sys.argv[0])
    program_version = "v0.1"
    program_build_date = "%s" % __updated__

    program_version_string = '%%prog %s (%s)' % (program_version, program_build_date)
    #program_usage = '''usage: spam two eggs''' # optional - will be autogenerated by optparse
    program_longdesc = '''''' # optional - give further explanation about what the program does
    program_license = "Copyright 2014 user_name (organization_name)                                            \
                Licensed under the Apache License 2.0\nhttp://www.apache.org/licenses/LICENSE-2.0"

    if argv is None:
        argv = sys.argv[1:]
    try:
        # setup option parser
        parser = OptionParser(version=program_version_string, epilog=program_longdesc, description=program_license)
        parser.add_option("-t", "--team", dest="team", help="Team ID to create test cases for current sprint")

        # process options
        (opts, args) = parser.parse_args(argv)

        gus = BacklogClient()
        qa = QAForceClient()
        
        if opts.team is not None:
            sprint = gus.get_current_sprint_for_team(opts.team)
            work_list = gus.get_work_ids_for_sprint(sprint)
        else:
            work_list = []    
            for arg in args:
                work = gus.find_work(arg)
                work_list.append(work['Id'])
            
        for work in work_list:
            test_cases = qa.get_test_case_ids_for_story(work)
            if len(test_cases) == 0:
                all_ac = gus.get_acceptance_criteria_for_work(work)
                for ac in all_ac:
                    acceptance = gus.get_acceptance_criterion_record(ac)
                    tc = qa.create_test_case(acceptance['Name'], 'Radian6.AUTOGEN', 'Planned', acceptance['Description__c'])
                    test_case = qa.get_test_case_record(tc['id'])
                    qa.create_test_execution(test_case['Id'], work)
                    
                    print("Test Case {} created and assigned to work record {}".format(test_case['Name'], work))
            else:
                print("Test Cases exist for Story")
            
        

    except Exception as e:
        raise e
        indent = len(program_name) * " "
        sys.stderr.write(program_name + ": " + repr(e) + "\n")
        sys.stderr.write(indent + "  for help use --help")
        return 2


if __name__ == "__main__":
    sys.exit(main())