#!/Users/scrosby/virtuals/py27/bin/python
# encoding: utf-8
'''
bin.gus_update_test_executions -- shortdesc

bin.gus_update_test_executions is a description

It defines classes_and_methods

@author:     user_name

@copyright:  2014 organization_name. All rights reserved.

@license:    license

@contact:    user_email
@deffield    updated: Updated
'''

import sys
import os, requests

from gus.QAForceClient import QAForceClient

from optparse import OptionParser

__all__ = []
__version__ = 0.1
__date__ = '2014-08-25'
__updated__ = '2014-08-25'

def main(argv=None):
    '''Command line options.'''

    program_name = os.path.basename(sys.argv[0])
    program_version = "v0.1"
    program_build_date = "%s" % __updated__

    program_version_string = '%%prog %s (%s)' % (program_version, program_build_date)
    #program_usage = '''usage: spam two eggs''' # optional - will be autogenerated by optparse
    program_longdesc = '''''' # optional - give further explanation about what the program does
    program_license = "Copyright 2014 user_name (organization_name)                                            \
                Licensed under the Apache License 2.0\nhttp://www.apache.org/licenses/LICENSE-2.0"

    if argv is None:
        argv = sys.argv[1:]
    try:
        # setup option parser
        parser = OptionParser(version=program_version_string, epilog=program_longdesc, description=program_license)
        # process options
        (opts, args) = parser.parse_args(argv)
        qa = QAForceClient()
        r = requests.get("https://the-test-log-server.herokuapp.com/execution", headers={'content-type':'application/json'})
        executions = r.json()
        
        for execution in executions:
            try:
                # create or update execution in gus
                work = qa.find_work(execution['gus_id'])
                ftest_id = "{}_{}".format(execution['gus_id'], execution['scenario_name'])
                test_case = qa.get_or_create_test_case_for_ftest(execution['scenario_name'], "Radian6.AUTOGEN", execution['test_type'], execution['scenario_detail'], ftest_id)
                qa.get_or_create_test_execution_for_test_case(work['Id'], test_case['Id'])
                if execution['pass_fail'] == True:
                    status = 'Passed'
                else:
                    status = 'Failed'
                qa.record_test_execution(work['Id'], test_case['Id'], execution['test_build'], execution['timestamp'], status)
                print("Updated Test Case: {}".format(test_case['Name']))
                
                # delete the execution record
                requests.delete("https://the-test-log-server.herokuapp.com/execution/{}".format(execution['id']))
            except Exception as e:
                print("Error updating test cases: {}".format(e))
                raise e

    except Exception, e:
        indent = len(program_name) * " "
        sys.stderr.write(program_name + ": " + repr(e) + "\n")
        sys.stderr.write(indent + "  for help use --help")
        return 2


if __name__ == "__main__":
    sys.exit(main())